Bug 1125926 - 'rhc app-show --gears' lists jbossas and jbosseap cartridges four times for scalable apps
Summary: 'rhc app-show --gears' lists jbossas and jbosseap cartridges four times for s...
Keywords:
Status: CLOSED WONTFIX
Alias: None
Product: OpenShift Online
Classification: Red Hat
Component: oc
Version: 2.x
Hardware: Unspecified
OS: Unspecified
medium
low
Target Milestone: ---
: ---
Assignee: Fabiano Franz
QA Contact: libra bugs
URL:
Whiteboard:
Depends On:
Blocks: 1130028
TreeView+ depends on / blocked
 
Reported: 2014-08-01 11:12 UTC by Wenjing Zheng
Modified: 2015-06-12 01:53 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
: 1130028 (view as bug list)
Environment:
Last Closed: 2015-06-12 01:53:21 UTC


Attachments (Terms of Use)

Description Wenjing Zheng 2014-08-01 11:12:31 UTC
Description:
Jbossas and jbosseap cartridges are  displayed four times on scalable apps with 'rhc app-show --gears'
[wzheng@rh6-openshift ~]$ rhc app-show as -g
ID                       State   Cartridges                                          Size  SSH URL
------------------------ ------- --------------------------------------------------- ----- ----------------------------------------------------------------------------
53db61a4dbd93cb8cd00161c started jbossas-7 jbossas-7 jbossas-7 jbossas-7 haproxy-1.4 small 53db61a4dbd93cb8cd00161c@as-lxiasilver.stg.rhcloud.com


Version-Release number of selected component (if applicable):
STG(devenv-stage_939)
rhc-1.28.5

How reproducible:
always
steps to Reproduce:
1. Create a scalable Jbossas-7 or jbosseap app
2. Show the gears with rhc app show $appname -g

Actual results:
There will be four jboss displayed on each gear

Expected results:
The cartridge should be displayed only once:
[wzheng@rh6-openshift ~]$ rhc app-show as -g
ID                       State   Cartridges                                          Size  SSH URL
------------------------ ------- --------------------------------------------------- ----- ----------------------------------------------------------------------------
53db61a4dbd93cb8cd00161c started php-5.4 haproxy-1.4 small 53db61a4dbd93cb8cd00161c@as-lxiasilver.stg.rhcloud.com


Additional info:
Also tried with php-5.4, nodejs-0.10, jbossews, all of them doesn't have this issue.

Comment 1 Wenjing Zheng 2014-10-24 10:28:44 UTC
rhc version:1.31.5,"aerogear-aerogear-push-1.0.1" displayes three times:
[openshift@openshift push1s]$ rhc app-show push1s -g
ID                       State   Cartridges                                                     Size   Region        Zone           SSH URL
------------------------ ------- -------------------------------------------------------------- ------ ------------- -------------- -------------------------------------------------------------------
544a24092587c8c627000c65 started mysql-5.5                                                      medium aws-us-east-1 aws-us-east-1c 544a24092587c8c627000c65@544a24092587c8c627000c65-d.stg.rhcloud.com
544a24092587c8c627000c64 started aerogear-aerogear-push-1.0.1 aerogear-aerogear-push-1.0.1      medium aws-us-east-1 aws-us-east-1c 544a24092587c8c627000c64@push1s-d.stg.rhcloud.com
                                 aerogear-aerogear-push-1.0.1 haproxy-1.4
544a28d12587c84a5e001352 started aerogear-aerogear-push-1.0.1 aerogear-aerogear-push-1.0.1      medium aws-us-east-1 aws-us-east-1c 544a28d12587c84a5e001352@544a28d12587c84a5e001352-d.stg.rhcloud.com
                                 aerogear-aerogear-push-1.0.1

Comment 2 DeShuai Ma 2014-11-06 09:55:53 UTC
rhc version:1.31.5,"jboss-jboss-unified-push-1.0.1" displayes four times:
1.create scaleble jboss-jboss-unified-push app
# rhc app-create -a push3 jboss-jboss-unified-push-1.0.1 -s
2.scale-up the app
# rhc app-scale-up -a push
3.show the gears of the app
[root@dhcp-128-7 apps]# rhc app-show -a push3 --gears
ID                       State   Cartridges                                                                                       Size  Region        Zone           SSH URL
------------------------ ------- ------------------------------------------------------------------------------------------------ ----- ------------- -------------- ------------------------------------------------------------------------
545b3b8edbd93c986a000efa started mysql-5.5                                                                                        small aws-us-east-1 aws-us-east-1c 545b3b8edbd93c986a000efa@545b3b8edbd93c986a000efa-eveusb.stg.rhcloud.com
545b3b8edbd93c986a000ef9 started jboss-jboss-unified-push-1.0.1 jboss-jboss-unified-push-1.0.1 jboss-jboss-unified-push-1.0.1     small aws-us-east-1 aws-us-east-1e 545b3b8edbd93c986a000ef9@push3-eveusb.stg.rhcloud.com
                                 jboss-jboss-unified-push-1.0.1 haproxy-1.4
545b40652587c85b65001b29 started jboss-jboss-unified-push-1.0.1 jboss-jboss-unified-push-1.0.1 jboss-jboss-unified-push-1.0.1     small aws-us-east-1 aws-us-east-1c 545b40652587c85b65001b29@545b40652587c85b65001b29-eveusb.stg.rhcloud.com
                                 jboss-jboss-unified-push-1.0.1

Comment 3 openshift-github-bot 2015-05-22 22:36:28 UTC
Commit pushed to master at https://github.com/openshift/rhc

https://github.com/openshift/rhc/commit/061f6f0ff39d37ec0a09b6ce9ce3850ed871244f
app show: highlight carts with endpoints

Modify app show --gears (1) to list all cartridges in the gear group for
a given gear and (2) to indicate cartridges that expose endpoints on the
gear by highlighting those cartridges' names in green.

The REST API does not provide an interface to determine which cartridges
are running on a gear; rather, we can only determine the gear group that is
associated with a gear and the endpoints that cartridges on that gear are
exposing.  On the one hand, the gear group associated with a given gear may
include cartridges that are not actually on that particular gear, and so if
we list the cartridges in the gear group, we may list cartridges that are
not actually on the gear.  On the other hand, a cartridge may be on a gear
but not be exposing any endpoints (e.g., the cron cartridge), and so if we
list only the cartridges that are exposing endpoints on the gear, we may
fail to list some cartridges that are in fact on the gear.

Prior to commit d858baefbad9d0d85ee46fa05a8642d169cad039, we chose the
first option of listing all cartridges in the gear group, including false
positives.  Commit d858baefbad9d0d85ee46fa05a8642d169cad039 changed app
show --gears to implement the second option of listing cartridges that were
exposing endpoints, which caused false negatives, as well as duplicate
entries for a cartridge that were exposing multiple endpoints.

With this commit, a cartridge may be listed for a gear even if it is not
actually on that gear, but the green highlight or absence thereof should
make it clear in the case of a cartridge that normally exposes endpoints
whether that cartridge really is present on a gear or whether it is merely
associated with the gear through the gear group but is not actually present
on the particular gear.

This commit addresses bug 1125926 and bug 1130028.


Note You need to log in before you can comment on or make changes to this bug.